require 'rexml/document'
require 'rexml/streamlistener'

include REXML

require 'rubygems'
require 'text'

include Text::Metaphone

require 'romanize'

class Listener

	@number = ''
	@unicode = ''
	@betacode = ''
	@romanization = ''
	@sound = ''
	@definition = ''
    @recording = false
	@last_tag = ''

	include StreamListener

	def tag_start(name, attributes)
		if name == 'entry' then
			@number = attributes['strongs'].to_i
            @counter = 0;
		end
		if name == 'greek' then 
			if @recording then
				@definition << " #{attributes['unicode']} "
			end
            if @counter == 0 then
				@unicode = attributes['unicode']
				@betacode = attributes['BETA']
				@romanization = attributes['translit']
                @sound = metaphone(@romanization)
            end
            @counter += 1
		end	
		if name == 'latin' then 
            @definition << " #{attributes['unicode']} "
        end
		if name == 'strongs_def' then
			@recording = true
			@definition = ''
		end
	end
	def text(content)
		if @recording then
			@definition << content.gsub(/\s+/, ' ').strip 
		end
	end
	def tag_end(name)
		if name == 'strongs_def' then
			@recording = false
		end
		if name == 'entry' then
            i = @number.to_i
			puts "INSERT INTO text_strongs (`number`, `unicode`, `betacode`, `transliteration`, `romanization`, `sound`, `meaning`) VALUES (\"#{@number}\", \"#{@unicode}\", \"#{@betacode}\", \"#{@romanization}\", \""+romanize(@unicode)+"\", \"#{@sound}\", \"#{@definition.gsub('"', '\"')}\");"
		end
	end
end

listener = Listener.new
parser = Parsers::StreamParser.new(File.new("strongsgreek.xml"), listener)
parser.parse
